#!/usr/bin/env python
# -*- coding: utf-8 -*-

#2016/ 3/ 7:ver1.00_h27
#2016/ 3/ 9:ver2.00_160309
    #TETRAに対応、GUIの変更
#2016/ 8/25:ver2.00_160825
    #.peridigmファイルの出力
#2016/ 9/ 4:ver2.00_160904
    #GUIによってPeridigmを最後まで実行可能
#2016/ 9/19:ver2.00_160918
    #乱数による座標の散らばりを追加
    #Horizonを自動生成可能
#2016/ 9/29:ver2.00_160929
    #Horizonを手入力に変更
    #脆性モデル、靭性モデルの選択を可能
#2016/10/ 4:ver2.00_161004
    #outputの選択可能に変更
    #GUIを変更
#2016/10/12:ver2.00_161012
    #解析時間の表示
#2016/12/ 7:ver3.00_161207
    #全操作をGUI化、Treeの子を作成、GUIを大幅に変更
#2016/12/ 8:ver3.00_161208
    #タブを切り替えるたびにGUIをリセット
#2016/12/30:ver3.00_161230
    #combobox以外のGUI表示を保持、FRAXSTのみでの解析に成功
#2017/ 1/ 3:ver3.00_170103
    #人為的ミスに対してerrorlogを表示
#2017/ 1/10:ver3.00_170110
    #CPU数を自動取得、comboboxのGUI表示を保持、解析ファイルの自動作成

#モジュールのimport
import sys   
import os   
import os.path   
import pygtk
pygtk.require("2.0")
import gtk
import glob
import csv
import pyFistr
import math
import gettext
import random
import numpy as np
import time
import multiprocessing

MaterialNamelist = []
BoundaryNamelist = []
Boundarylist = []
Materiallist = []
Brittlenesslist = []
materialDBCont = []

matcount = 0

version = "3.00_170110"
ls = os.linesep         #行末コード

datafile = "/opt/peridigm/fraxst/fraxst_data"

ls = "\n"

materialDBName = ""

def materialTypes():
    matTypes = [(u"塑性モデル"),(u"弾塑性モデル"),
                (u"弾性硬化モデル"),(u"粘弾性モデル")]
    return matTypes
def materialTypesE():
    matTypes = [("Elastic"),("Elastic Plastic"),
                ("Elastic Plastic Hardening"),("Viscoelastic")]
    return matTypes

def analysisTypes():
    anaTypes = [(u"変位制御(m)"),(u"初速度(m/s)"),
            (u"温度制御"),(u"体積力")]
    return anaTypes

def analysisTypesE():
    anaTypes = [("Prescribed Displacement"),("Initial Velocity"),
                ("Prescribed Temperature"),("Body Force")]
    return anaTypes

#Treeの構成
def initialTreeParts():
    root1 = [(u"FRAXST for Peridigm")]
    root2 = [(u"Irregularity_Particle")]
    root3 = [(u"Convert_data")]
    root4 = [(u"Convert_Genesis")]
    root5 = [([u"Set_Material",MaterialNamelist]
              )]
    root6 = [([u"Set_Boundary",BoundaryNamelist]
              )]
    root7 = [(u"Convert_Peridigm")]
    root8 = [(u"Run_Peridigm")]

    return [root1,root2,root3,root4,root5,root6,root7,root8]
####################################################################################################

class windowApp:
    def __init__(self):
        #Set the Glade file
        gladefile = "fraxst.glade"
        self.builder = gtk.Builder()
        self.builder.add_from_file(os.path.dirname(os.path.abspath(__file__)) +
                "/"+gladefile)
      
        self.setGtkObject()
        self.initialize()
        #Setcombobox
        self.setmaterialNametocombobox()
        self.setanalysistypestocombobox()
        #材料物性値
        self.readMaterialDB()
        self.setMaterialNameToListBox()

        title = "FRAXST for Peridigm  (ver " + version + ")"
        self.label_title.set_label(title)
        self.versionLabel.set_label("ver "+version)
        
        self.builder.connect_signals(self)
        self.mainWindow = self.builder.get_object ("window1")
        title = "FRAXST : " + os.environ.get("USER")
        self.mainWindow.set_title(title)
        self.mainWindow.show_all()

        self.subWindow = self.builder.get_object ("window2")

    #    object名をセット（定義）
    def setGtkObject(self):
        #treeのmodelを定義
        self.treestore = gtk.TreeStore(str)
        #listのmodelを定義
        self.listmodelallunvFile = gtk.ListStore(str)
        self.listmodelalldatFile = gtk.ListStore(str)
        self.listmodeluseHEX8unv = gtk.ListStore(str)
        self.listmodeluseTETRAunv = gtk.ListStore(str)
        self.listmodelusedat = gtk.ListStore(str)
        self.listmodelMatName = gtk.ListStore(str)
        self.listshotmodelMatName = gtk.ListStore(str)
        #comboboxのmodelを定義
        self.comboboxmatTypes = gtk.ListStore(str)
        self.listmodelMatName = gtk.ListStore(str)
        self.comboboxanaTypes = gtk.ListStore(str)
        #objectのnameを定義
          #   treeviewのnameを定義
        self.tree_main = self.builder.get_object("treeview1")
        self.listBox_allunvfile = self.builder.get_object("treeview2")
        self.listBox_HEXunvfile = self.builder.get_object("treeview3")
        self.listBox_TETRAunvfile = self.builder.get_object("treeview4")
        self.listBox_alldatfile = self.builder.get_object("treeview5")
        self.listBox_usedatfile = self.builder.get_object("treeview6")
          #   labelのnameを定義
        self.label_title = self.builder.get_object("label1")
        self.versionLabel = self.builder.get_object("label5")
        self.gfileinfo = self.builder.get_object("label20")
          #   notebookのnameを定義
        self.notebook_main = self.builder.get_object("notebook1")
          #   entryのnameを定義
        self.textCtrl_workFolder = self.builder.get_object("entry1")
        self.textCtrl_useperidigm = self.builder.get_object("entry2")
        self.textCtrl_savetxtfile = self.builder.get_object("entry3")
        self.textCtrl_usetxtfile = self.builder.get_object("entry4")
        self.textCtrl_savegfile = self.builder.get_object("entry5")
        self.textCtrl_SalomePATH = self.builder.get_object("entry6")
        self.textCtrl_ParaviewPATH = self.builder.get_object("entry7")
        self.textCtrl_MaterialDataPATH = self.builder.get_object("entry8")
        self.textCtrl_matDB = self.builder.get_object("entry9")
        self.textCtrl_Value_X = self.builder.get_object("entry10")
        self.textCtrl_Value_Y = self.builder.get_object("entry11")
        self.textCtrl_Value_Z = self.builder.get_object("entry12")
        self.textCtrl_PeridigmFile = self.builder.get_object("entry13")
        self.textCtrl_Final_Time = self.builder.get_object("entry14")
        self.textCtrl_Fix_dt = self.builder.get_object("entry15")
        self.textCtrl_RunGenesisfile = self.builder.get_object("entry16")
        self.textCtrl_RunPeridigmfile = self.builder.get_object("entry17")
        self.textCtrl_Setefile = self.builder.get_object("entry18")
        self.textCtrl_CPUcore = self.builder.get_object("entry19")
        self.textCtrl_Surrender_Young = self.builder.get_object("entry20")
        self.textCtrl_Delay_time = self.builder.get_object("entry21")
        self.textCtrl_Relaxation_time = self.builder.get_object("entry22")
        self.textCtrl_search_radius = self.builder.get_object("entry24")
        self.textCtrl_search_frequency = self.builder.get_object("entry25")
        self.textCtrl_contact_radius = self.builder.get_object("entry26")
        self.textCtrl_spring_constact = self.builder.get_object("entry27")
        self.textCtrl_horizon = self.builder.get_object("entry28")
        self.textCtrl_Critical_Stretch = self.builder.get_object("entry30")
        self.textCtrl_HEX_irregularity = self.builder.get_object("entry31")
        self.textCtrl_HEX_intergrain_distance = self.builder.get_object("entry32")
        self.textCtrl_TETRA_irregularity = self.builder.get_object("entry33")
        self.textCtrl_TETRA_intergrain_distance = self.builder.get_object("entry34")
        self.textCtrl_output_frequency = self.builder.get_object("entry35")
        self.textCtrl_matDB.set_text("/opt/peridigm/fraxst/materialFRAXST.csv")
        #初期設定---------------------------------------------------------------
        self.textCtrl_Surrender_Young.set_sensitive(False)
        self.textCtrl_Delay_time.set_sensitive(False)
        self.textCtrl_Relaxation_time.set_sensitive(False)
        self.textCtrl_Critical_Stretch.set_sensitive(False)
        #self.textCtrl_Value_X.set_text("0")
        #self.textCtrl_Value_Y.set_text("0")
        #self.textCtrl_Value_Z.set_text("0")
        #self.textCtrl_Final_Time.set_text("0.5")
        self.textCtrl_Fix_dt.set_text("1.0E-6")
        self.textCtrl_Setefile.set_text("samlpe")
        #self.textCtrl_Surrender_Young.set_text("100")
        #self.textCtrl_Delay_time.set_text("0.005")
        #self.textCtrl_Relaxation_time.set_text("0.005")
        #self.textCtrl_search_radius.set_text("0.05")
        self.textCtrl_search_frequency.set_text("1")
        #self.textCtrl_contact_radius.set_text("0.02")
        self.textCtrl_spring_constact.set_text("1.0E+10")
        #self.textCtrl_horizon.set_text("0.1")
        #self.textCtrl_Critical_Stretch.set_text("0.2")
        self.textCtrl_output_frequency.set_text("100")
        #self.textCtrl_Final_Time.set_text("0.5")
        self.textCtrl_CPUcore.set_sensitive(False)
        
          #   comboboxのnameを定義
        self.comboBox_matModel = self.builder.get_object("combobox1")
        self.comboBox_matName = self.builder.get_object("combobox2")
        self.comboBox_anaTypes = self.builder.get_object("combobox3")

          #   checkのnameを定義
        self.checkBtn_HEX_irregularity = self.builder.get_object("checkbutton1")
        self.checkBtn_brittleness = self.builder.get_object("checkbutton2")
        self.checkBtn_contact = self.builder.get_object("checkbutton3")
        self.checkBtn_Displacement = self.builder.get_object("checkbutton4")
        self.checkBtn_Velocity = self.builder.get_object("checkbutton5")
        self.checkBtn_Element_Id = self.builder.get_object("checkbutton6")
        self.checkBtn_Proc_Num = self.builder.get_object("checkbutton7")
        self.checkBtn_Dilatation = self.builder.get_object("checkbutton8")
        self.checkBtn_Weighted_Volume = self.builder.get_object("checkbutton9")
        self.checkBtn_Force = self.builder.get_object("checkbutton10")
        self.checkBtn_Contact_Force = self.builder.get_object("checkbutton11")
        self.checkBtn_Damage = self.builder.get_object("checkbutton12")
        self.checkBtn_Number_Of_Neighbors = self.builder.get_object("checkbutton13")
        self.checkBtn_Radius = self.builder.get_object("checkbutton14")
        self.checkBtn_Acceleration = self.builder.get_object("checkbutton15")
        self.checkBtn_Force_Density = self.builder.get_object("checkbutton16")
        self.checkBtn_solvePara = self.builder.get_object("checkbutton17")
        self.checkBtn_TETRA_irregularity = self.builder.get_object("checkbutton18")
        #初期設定---------------------------------------------------------------
        self.checkBtn_contact.set_active(True)
        self.checkBtn_Displacement.set_active(True)
        self.checkBtn_Velocity.set_active(True)
        self.checkBtn_Damage.set_active(True)
        self.checkBtn_Force.set_active(True)
        self.checkBtn_solvePara.set_active(False)

#===================================================================================================
    #　各動作の設定
    #----- windowを直接閉じる -----------------------
    #閉じる
    def close(self, windows, event):
        gtk.main_quit()

    #----- TreeItem選択 ----------------------------
    #  項目選択時
    def onSelectItem(self, event):
        self.selectItem(event)

    #  close
    def onClose(self, event):
        sys.exit(0)

    #　環境設定
    def onEnvironSet(self, event):
        self.environset(event)

    #  salome起動
    def onRunSalome(self, event):
        self.runsalome(event)
        
    #  paraview起動
    def onRunParaview(self, event):
        self.runparaview(event)
        
    #  editor起動
    def onRunEditor(self, event):
        self.runeditor(event)

#----- FRAXST for Peridigm page ------------------------------------------------
    #  参照...
    def onSelectWorkFolder(self, event):
        self.selectWorkFolder(event)

    def onSetUsePeridigmFile(self, event):
        self.setuseperidigmfile(event)

#----- Convert_data page -------------------------------------------------------
    #  選択>>
    def onAddHEXunvfile(self, event):
        self.addHEXunvfile(event)

    #  <<戻す
    def onDeleteHEXunvfile(self, event):
        self.deletHEXeunvfile(event)

    #  選択>>
    def onAddTETRAunvfile(self, event):
        self.addTETRAunvfile(event)

    #  <<戻す
    def onDeleteTETRAunvfile(self, event):
        self.deletTETRAeunvfile(event)
        
    #  選択>>
    def onAdddatfile(self, event):
        self.adddatfile(event)

    #  <<戻す    
    def onDeletedatfile(self, event):
        self.deletedatfile(event)

    #  参照...
    def onSavetxtfile(self, event):
        self.savetxtfile(event)

    #  ファイル変換
    def onConvertData(self, event):
        self.convertdata(event)

#----- Convert_Genesis page ----------------------------------------------------
    #  参照...
    def onConvertTxtfile(self, event):
        self.converttxtfile(event)

    #  参照...
    def onSaveGenesisfile(self, event):
        self.savegenesisfile(event)

    #  ファイル変換
    def onConvertGenesis(self, event):
        self.convertgenesis(event)
    
    #  形状確認
    def onConfirmModelAtParaview(self, event):
        self.confirmModelAtParaview(event)

#---- Set_Material page---------------------------------------------------------
    #  setMaterialDB(参照...)
    def onSetMaterialDB(self, event):
        self.setMaterialDB(event)

#---- Set_Material_sub page-----------------------------------------------------
    #  物性値の確認
    def onShowMaterialData(self,event):
        self.showmaterialdata(event)

    #  物性値の決定
    def onSetMaterialsub(self,event):
        self.setmaterialsub(event)
    #  入力範囲の切り替え
    def changeMaterialModel(self,event):
        self.changematerialmodel(event)
        
    def onBrittleness(self,event):
        self.onbrittleness(event)

#---- Set_Boundary page---------------------------------------------------------
    #  接触条件の決定
    def onSetBoundary(self,event):
        self.setboundary(event)

    def onContact(self,event):
        self.oncontact(event)

#---- Set_Boundary_sub page-----------------------------------------------------
    #  境界条件の決定
    def onSetBoundarysub(self,event):
        self.setboundarysub(event)

#---- Convert_Peridigm page ----------------------------------------------------
    #  出力時間の設定
    def onSetSolver(self,event):
        self.setsolver(event)

    def onCheck_para(self,event):
        self.multiple_processing(event)
        
    #  peridigmファイルの選択
    def onPeridigmFile(self,event):
        self.peridigmfile(event)
        
    #  peridigmファイルへの変換
    def onConvertPeridigm(self,event):
        self.convertperidigm(event)

#----- solver page -------------------------------------------------------------
    #  gファイルの設定
    def onSetGenesisfile(self,event):
        self.setgenesisfile(event)

    #  peridigmファイルの設定
    def onSetPeridigmfile(self,event):
        self.setperidigmfile(event)

    #  peridigmの実行
    def onRunPeridigm(self,event):
        self.runperidigm(event)

    #  並列処理の有無
    def onSwitchParallel(self, event):
        self.switchParallel(event)

    #  形状確認
    def onComfirmEfile(self,event):
        self.comfirmefile(event)

#---- subwindow-----------------------------------------------------------------
    #  初期化
    def onEnvironinit(self, event):
        self.environinit(event)

    #  設定変更
    def onSaveEnvironment(self, event):
        self.saveenvironment(event)
    
    #  閉じる
    def onClosesub(self,event):
        self.subWindow.hide()
        return True

    #-------windowを直接閉じる
    #閉じる
    def subclose(self,window,event):
        self.subWindow.hide()
        return True

#===================================================================================================
    def initialize(self):
        #FRAXST_dataの読み込み、表示
        self.setfraxst_data()
        #Treeの作成
        makeIniTreeData()
        self.setIniTreeData()
        #titleページを表示
        showPage = (u"FRAXST")
        self.showNoteBook(showPage)

    #---- 端末-------------------------------
    #  runTerminal
    #    端末を起動する
    def runTerminal(self, event):
        comm = runTerminalComm
        os.system(comm)
    #---- openWorkFolder---------------------
    #    currDirを開く
    def openWorkFolder(self, event):
        comm = runFileManagerComm + " " + currDir
        os.system(comm)


    #  fraxst_dataから各データを表示
    def setfraxst_data(self):
        istrData = getSavedData()
        for i in range(len(istrData)):
            item = istrData[i].split()
            if item[0] == u'workfolder':
                self.textCtrl_workFolder.set_text(item[1])
            elif item[0] == u'usefile':
                self.textCtrl_useperidigm.set_text(item[1].split("/")[-1])
            elif item[0] == u'materialdata':
                self.textCtrl_MaterialDataPATH.set_text(item[1])
            elif item[0] == u'salome':
                self.textCtrl_SalomePATH.set_text(item[1])
            elif item[0] == u'paraview':
                self.textCtrl_ParaviewPATH.set_text(item[1])

    #    初期のTreeを作成
    def setIniTreeData(self):
        rootName = treeData[0]
        items = treeData[1]
        #treeMainをクリアする
        self.treeMainClear()
        #rootを追加
        root = self.treestore.append(None, [rootName])
        #root以下をmodelに追加
        self.addTreeNodes(self.treestore, root, items)
        #treeViewにmodelを追加
        self.tree_main.set_model(model=self.treestore)
        #treeのlabelを1行目に追加
        self.tvcolumn = gtk.TreeViewColumn("Column 0")
        self.tree_main.append_column(self.tvcolumn)
        #treeを作成
        self.cell = gtk.CellRendererText()
        self.tvcolumn.pack_start(self.cell, True)
        self.tvcolumn.add_attribute(self.cell, "text", 0)
        #rootを展開
        self.tree_main.expand_row(0, False)

    #  treeMainをクリア
    def treeMainClear(self):
        self.treestore.clear()
        col = self.tree_main.get_column(0)
        if col != None:
            self.tree_main.remove_column(col)

    #  addTreeNodes
    def addTreeNodes(self, treeStore, parentItem, items):
        for item in items:
            if type(item) == str or type(item) == unicode:
                newItem = treeStore.append(parentItem, [item])
            else:
                newItem = treeStore.append(parentItem, [item[0]])
                self.addTreeNodes(treeStore, newItem, item[1])

    #  showNoteBook
    def showNoteBook(self, name):
        pageText = ""
        nPage = self.notebook_main.get_n_pages()
        i = 0
        while i < nPage:
            page = self.notebook_main.get_nth_page(i)
            pageName = self.notebook_main.get_tab_label_text(page)
            if pageName == name:
                self.notebook_main.set_current_page(i)
                break
            i += 1

    #    Treeの項目選択
    def selectItem(self, event):
        treeCtrl = self.tree_main
        treeStore = self.treestore
        path, column = treeCtrl.get_cursor()
        #選択したpageのnameを取得
        name = self.getNameInTreeData(path)
        self.pagename = name
        #選択したpageの親のnameを取得
        parentName = self.getParentNameInTreeData(path)
        #表示するpageの名前を取得
        showPage = self.getShowPageName(parentName, name)
        #各pageごとの表示設定
        if showPage == u"Convert_data":
            self.setfile()
            self.setunvdatfiles()
        if showPage == u"Set_Material_sub":
            self.materialclear()
        if showPage == u"Set_Boundary_sub":
            self.boundaryclear()
            
        #選択したpageの表示
        self.showNoteBook(showPage)

    #    path(タプル)からtreeDataのparentを取得
    def getParentNameInTreeData(self, path):
        dPath = []
        dPath = path
        parent = self.getNameInTreeData(dPath[:-1])
        return parent

    #    path(タプル)からtreeDataのnameを取得
    def getNameInTreeData(self, path):
        tree = [treeData]
        name = ""
        for n in path:
            nTree = tree[n]
            if type(nTree) == str or type(nTree) == unicode:
                name = nTree
            else:
                name = nTree[0]
                tree = nTree[1]
        ans = name
        return ans

    def getShowPageName(self, parentName, name):
        pageName = ""
        if parentName == u"Set_Material":
            pageName = u"Set_Material_sub"
        elif parentName == u"Set_Boundary":
            pageName = u"Set_Boundary_sub"
        else:
            if name == u"FRAXST for Peridigm":
                pageName = u"FRAXST"
            elif name == u"Irregularity_Particle":
                pageName = u"Irregularity_Particle"
            elif name == u"Convert_data":
                pageName = u"Convert_data"
            elif name == u"Convert_Genesis":
                pageName = u"Convert_Genesis"
            elif name == u"Set_Material":
                pageName = u"Set_Material"
            elif name == u"Set_Boundary":
                pageName = u"Set_Boundary"
            elif name == u"Convert_Peridigm":
                pageName = u"Convert_Peridigm"
            elif name == u"Run_Peridigm":
                pageName = u"Run_Peridigm"
        return pageName

    #    作業用folderを設定
    def selectWorkFolder(self, event):
        currDir = self.textCtrl_workFolder.get_text()

        title = (u"作業用folderの選択")
        result = self.dirDialog(title, currDir)
        item = 'workfolder'
        self.runperidigmworkName = currDir
        if result != "":
            currDir = result
            self.textCtrl_workFolder.set_text(currDir)
            print "作業folderを　" + ("%s" % currDir) + "　に設定しました"
            self.changedatafile(item, currDir)
            os.chdir(currDir)

    #  制御fileの選択
    def setuseperidigmfile(self,event):
        dbDir = self.textCtrl_workFolder.get_text()
        oldfileName = self.textCtrl_useperidigm.get_text()
        title = (u"制御ファイルの選択")
        filterSets = [[(u"peridigmファイル"), "*.peridigm"]]
        fileName = self.fileDialog(title, dbDir, filterSets)
        if fileName == "":
            fileName = oldfileName
        else:
            if fileName[-9:] != u".peridigm":
                fileName += u".peridigm"
            fileName = fileName.split("/")[-1]
            print "制御fileを　" + ("%s" % fileName) + "　に設定しました"
        self.textCtrl_useperidigm.set_text(fileName)
        item = 'usefile'
        path = fileName
        self.changedatafile(item, path)

    def setunvdatfiles(self):
        self.clearallfilelist()
        self.setunvfile()
        self.setdatfile()

    #    unv,datの表示のリセット
    def clearallfilelist(self):
        self.listmodelallunvFile.clear()
        self.listmodelalldatFile.clear()
        self.listmodeluseHEX8unv.clear()
        self.listmodeluseTETRAunv.clear()
        self.listmodelusedat.clear()
    #  ファイルの自動生成
    def setfile(self):
        dbDir = self.textCtrl_workFolder.get_text()
        txtfileName = "sample.txt"
        self.textCtrl_savetxtfile.set_text(txtfileName)
        self.textCtrl_usetxtfile.set_text(dbDir + "/" + txtfileName)
        gfileName = "sample.g"
        self.textCtrl_savegfile.set_text(dbDir + "/" + gfileName)
        self.textCtrl_RunGenesisfile.set_text(dbDir + "/" + gfileName)
        peridigmfileName = "sample.peridigm"
        self.textCtrl_PeridigmFile.set_text(dbDir + "/" + peridigmfileName)
        self.textCtrl_RunPeridigmfile.set_text(dbDir + "/" + peridigmfileName)

    #  作業folder内のunvfileを表示
    def setunvfile(self):
        global MaterialNamelist
        workfolder = self.textCtrl_workFolder.get_text()
        unvfiles = glob.glob(workfolder + "/" + "*.unv")
        unvnames = []
        for fileName in unvfiles:
            unvname = fileName.split("/")[-1]
            unvnames.append(unvname)
        self.setListDataInListBox(self.listmodelallunvFile, self.listBox_allunvfile, unvnames)
        self.unvnames = unvnames
        MaterialNamelist = unvnames

    #  作業folder内のdatfileを表示
    def setdatfile(self):
        workfolder = self.textCtrl_workFolder.get_text()
        datfiles = glob.glob(workfolder + "/" + "*.dat")
        datnames = []
        for fileName in datfiles:
            datname = fileName.split("/")[-1]
            datnames.append(datname)
        self.setListDataInListBox(self.listmodelalldatFile, self.listBox_alldatfile, datnames)
        self.datnames = datnames

    def addHEXunvfile(self,event):
        self.moveItemToListBox(self.listBox_allunvfile, self.listmodelallunvFile,
                               self.listBox_HEXunvfile, self.listmodeluseHEX8unv)

    def deletHEXeunvfile(self,event):
        self.moveItemToListBox(self.listBox_HEXunvfile, self.listmodeluseHEX8unv,
                               self.listBox_allunvfile, self.listmodelallunvFile)

    def addTETRAunvfile(self,event):
        self.moveItemToListBox(self.listBox_allunvfile, self.listmodelallunvFile,
                               self.listBox_TETRAunvfile, self.listmodeluseTETRAunv)

    def deletTETRAeunvfile(self,event):
        self.moveItemToListBox(self.listBox_TETRAunvfile, self.listmodeluseTETRAunv,
                               self.listBox_allunvfile, self.listmodelallunvFile)        

    def adddatfile(self,event):
        self.moveItemToListBox(self.listBox_alldatfile, self.listmodelalldatFile,
                               self.listBox_usedatfile, self.listmodelusedat)

    def deletedatfile(self,event):
        self.moveItemToListBox(self.listBox_usedatfile, self.listmodelusedat,
                               self.listBox_alldatfile, self.listmodelalldatFile)

    #  txt形式の保存名の選択
    def savetxtfile(self, event):
        dbDir = self.textCtrl_workFolder.get_text()
        title = (u"保存ファイルの選択")
        filterSets = [[(u"textファイル"), "*.txt"]]
        fileName = self.fileDialog(title, dbDir, filterSets)
        self.fileName = fileName
        if fileName == "":
            fileName = "sample.txt"
        else:
            if fileName[-4:] != u".txt":
                fileName += u".txt"
            fileName = fileName.split("/")[-1]
            print "保存fileを　" + ("%s" % fileName) + "　に設定しました"
        self.textCtrl_savetxtfile.set_text(fileName)
        self.textCtrl_usetxtfile.set_text(dbDir + "/" + fileName)

    def convertdata(self, event):
        global MaterialNamelist,BoundaryNamelist
        #作業フォルダー名
        self.workfolder = self.textCtrl_workFolder.get_text()
        #unvファイル名リスト
        self.HEXunvfilelist = self.getNamesInListmodel(self.listmodeluseHEX8unv)
        self.TETRAunvfilelist = self.getNamesInListmodel(self.listmodeluseTETRAunv)
        
        MaterialNamelist = self.HEXunvfilelist + self.TETRAunvfilelist
        #MaterialNamelist = self.unvnames
        for i in range(len(self.HEXunvfilelist)):
            self.HEXunvfilelist[i] = ['HEX8',self.HEXunvfilelist[i]]
        for i in range(len(self.TETRAunvfilelist)):
            self.TETRAunvfilelist[i] = ['TETRA',self.TETRAunvfilelist[i]]
        self.unvfilelist = self.HEXunvfilelist + self.TETRAunvfilelist
        #datファイル名リスト
        self.datfilelist = self.getNamesInListmodel(self.listmodelusedat)
        BoundaryNamelist = self.datfilelist
        #textファイル名
        self.savefilename = self.textCtrl_savetxtfile.get_text()

        if len(self.unvfilelist)  == 0 and len(self.datfilelist) == 0:
            title = (u"fileの選択")
            mess = (u"使用するfileを選択してください")
            self.errDialog(title, mess)
        elif len(self.unvfilelist) == 0 :
            title = (u"unvfileの選択")
            mess = (u"使用するunvfileを選択してください")
            self.errDialog(title, mess)
        elif len(self.datfilelist) == 0 :
            title = (u"datfileの選択")
            mess = (u"使用するdatfileを選択してください")
            self.errDialog(title, mess)
        elif self.savefilename == "" :
            title = (u"保存fileの選択")
            mess = (u"保存するfileを選択してください")
            self.errDialog(title, mess)
        elif len((self.textCtrl_savetxtfile.get_text()).split(".")) >= 3:
            title = (u"txt形式の保存名")
            mess = (u"拡張子以外の.を外してください")
            self.errDialog(title, mess)
            
        else:
            #[節点番号,X座標,Y座標,Z座標]
            self.nodelist = []
            self.nonodelist = []
            #立体要素の各頂点の節点番号
            self.elementnodes = []
            #グループ情報の各節点番号
            self.nodalpointlist = []

            #変換の実行
            self.onConvert()

        makeIniTreeData()
        self.setIniTreeData()

    #変換内容
    def onConvert(self):
        #unvファイルの並び替え
        self.sortunvfilelist()
        #unvファイルから節点数、節点番号、節点座標(X,Y,Z)、立体要素数、立体要素の各節点番号の抽出
        self.readunvfile()
        #datファイルから、グループ情報（境界条件）の節点数、節点番号の抽出
        self.readdatfile()
        #unv、datから抽出したデータの書き出し
        self.outputtxtfile()

    def sortunvfilelist(self):
        for i in range(len(self.unvfilelist)):
            fileName = self.workfolder + '/' + self.unvfilelist[i][1]
            f = open(fileName)
            g = f.readline()
            while g != '  2411\n' and g != '  2411\r\n':
                g = f.readline()
            g = f.readline()
            g = g.split()
            self.unvfilelist[i].append(int(g[0]))
            f.close()
        self.unvfilelist = sorted(self.unvfilelist, key = lambda x:x[2], reverse = False)
        for i in range(len(self.unvfilelist)):
            del self.unvfilelist[i][-1]

    def readunvfile(self):
        def readTETRA(fileName):
            fileName = self.workfolder + '/' + fileName
            f = open(fileName)
            g = f.readline()
            while g != '  2411\n' and g != '  2411\r\n':
                g = f.readline()
            while g != '    -1\n' and g != '    -1\r\n':
                data = []
                nodata = []
                g = f.readline()
                if g == '    -1\n' or g == '    -1\r\n':
                    break
                data.append(int(g.split()[0]))
                g = f.readline()
                if g == '    -1\n' or g == '    -1\r\n':
                    break
                
                if self.checkBtn_TETRA_irregularity.get_active() == True:
                    TETRA_irregularity = self.textCtrl_TETRA_irregularity.get_text()
                    TETRA_intergrain_distance = self.textCtrl_TETRA_intergrain_distance.get_text()

                    density = random.randint(1,101-(float(TETRA_irregularity)))
                    if density == 1:
                        a = np.random.normal(0.0,((float(TETRA_intergrain_distance))*0.1))
                        data.append((float(g.split()[0]))+a)
                        b = np.random.normal(0.0,((float(TETRA_intergrain_distance))*0.1))
                        data.append((float(g.split()[1]))+b)
                        c = np.random.normal(0.0,((float(TETRA_intergrain_distance))*0.1))
                        data.append((float(g.split()[2]))+c)
                        self.nodelist.append(data)
                    else:
                        data.append(float(g.split()[0]))
                        data.append(float(g.split()[1]))
                        data.append(float(g.split()[2]))
                        self.nodelist.append(data)
                else:
                    data.append(float(g.split()[0]))
                    data.append(float(g.split()[1]))
                    data.append(float(g.split()[2]))
                    self.nodelist.append(data)

            g = f.readline()
            g = f.readline()
            nodes = []
            while g != '    -1\n' and g != '    -1\r\n':
                if len(g.split()) == 4:
                    data = []
                    count = random.randint(1,1)
                    if count == 1:
                        for i in range(4):
                            data.append(int(g.split()[i]))
                        nodes.append(data)
                g = f.readline()
            self.elementnodes.append(nodes)
            f.close()
        
        def readHEX8(fileName):
            fileName = self.workfolder + '/' + fileName
            f = open(fileName)
            g = f.readline()
            while g != '  2411\n' and g != '  2411\r\n':
                g = f.readline()
            while g != '    -1\n' and g != '    -1\r\n':
                data = []
                nodata = []
                g = f.readline()
                if g == '    -1\n' or g == '    -1\r\n':
                    break
                data.append(int(g.split()[0]))
                g = f.readline()
                if g == '    -1\n' or g == '    -1\r\n':
                    break

                if self.checkBtn_HEX_irregularity.get_active() == True:
                    HEX_irregularity = self.textCtrl_HEX_irregularity.get_text()
                    HEX_intergrain_distance = self.textCtrl_HEX_intergrain_distance.get_text()

                    density = random.randint(1,101-(float(HEX_irregularity)))
                    if density == 1:
                        a = np.random.normal(0.0,((float(HEX_intergrain_distance))*0.1))
                        data.append((float(g.split()[0]))+a)
                        b = np.random.normal(0.0,((float(HEX_intergrain_distance))*0.1))
                        data.append((float(g.split()[1]))+b)
                        c = np.random.normal(0.0,((float(HEX_intergrain_distance))*0.1))
                        data.append((float(g.split()[2]))+c)
                        self.nodelist.append(data)
                    else:
                        data.append(float(g.split()[0]))
                        data.append(float(g.split()[1]))
                        data.append(float(g.split()[2]))
                        self.nodelist.append(data)
                else:
                    data.append(float(g.split()[0]))
                    data.append(float(g.split()[1]))
                    data.append(float(g.split()[2]))
                    self.nodelist.append(data)

            g = f.readline()
            g = f.readline()
            nodes = []
            while g != '    -1\n' and g != '    -1\r\n':
                if len(g.split()) == 8:
                    data = []
                    count = random.randint(1,1)
                    if count == 1:
                        for i in range(8):
                            data.append(int(g.split()[i]))
                        nodes.append(data)
                g = f.readline()
            self.elementnodes.append(nodes)
            f.close()
                
        for i in range(len(self.unvfilelist)):
            if self.unvfilelist[i][0] == 'TETRA':
                readTETRA(self.unvfilelist[i][1])
            elif self.unvfilelist[i][0] == 'HEX8':
                readHEX8(self.unvfilelist[i][1])

    def readdatfile(self):
        for fileName in self.datfilelist:
            fileName = self.workfolder + '/' + fileName
            f = open(fileName)
            data = []
            g = f.readline()
            for l in range(int((g.split())[0])):
                g = f.readline()
                data.append(int(g.split()[0]))
            f.close()
            self.nodalpointlist.append(data)

    def outputtxtfile(self):
        elements = 0
        node_set_list = 0
        
        nodes = len(self.nodelist)
        for i in range(len(self.elementnodes)):
            elements += len(self.elementnodes[i])
        element_blocks = len(self.unvfilelist)
        node_sets = len(self.datfilelist)
        for i in range(len(self.nodalpointlist)):
            node_set_list += len(self.nodalpointlist[i])
        dist_fact_length = node_set_list
            
        fileName = self.workfolder + '/' + self.savefilename
        f = open(fileName , 'w')
        f.write("""
! Database initial variables

        3      6.09        32     ! dimensions, version number, name length
%9s%10s%10s     ! nodes, elements, element blocks
%9s         0               ! #node sets, #side sets
%9s%10s               ! len: node set list, dist fact length
        0         0         0     ! side sets len: element, node , dist fact
! Coordinate names
X                                Y                              Z
! Coordinates\n""" % (nodes,elements,element_blocks,
                      node_sets,
                      node_set_list,dist_fact_length))
        for i in range(len(self.nodelist)):
            f.write('%16.8E%16.8E%16.8E\n' % (self.nodelist[i][1],self.nodelist[i][2],self.nodelist[i][3]))
        f.write("""! Node number map
sequence 1..numnp
! Element number map
sequence 1..numel
! Element order map
sequence 1..numel\n""")
        for i in range(element_blocks):
            f.write("""! Element block%5s
%10d%10d      %s     ! ID, elements, element type
%10s%10s       !nodes per element, attributes
! Connectivity\n""" % (i+1,
                       i+1,len(self.elementnodes[i]),self.unvfilelist[i][0],
                       len(self.elementnodes[i][1]),'0'))
            for l in range(len(self.elementnodes[i])):
                for k in range(len(self.elementnodes[i][l])):
                    f.write("%10s" % self.elementnodes[i][l][k])
                f.write("\n")
        f.write("""! Node sets%28d
! Len node set node list%15d
! Len node set dist fact list%10d\n""" % (node_sets,node_set_list,dist_fact_length))
        for i in range(node_sets):
            f.write("! Nodal point set %s\n" % str(i+1))
            f.write('%10s%10s%10s          ! ID, nodes dist factors\n' % (str(i+1),len(self.nodalpointlist[i]),len(self.nodalpointlist[i])))
            for l in range(len(self.nodalpointlist[i])):
                f.write('%10s     1.0000000E+00\n' % (self.nodalpointlist[i][l]))
        f.write("""!Properties
         1          ! Number of ELEMENT BLOCK Properties
!Property Name
ID
! Property Value(s):\n""")
        for i in range(len(self.unvfilelist)):
            f.write("%10s" % str(i+1))
        f.write("""\n         1          ! Number of NODE SET Properties
! Property Name
ID
! Property Value(s):\n""")
        for i in range(len(self.datfilelist)):
            f.write("%10s" % str(i+1))
        f.write("""\n         0          ! Number of SIDE SET Properties
! QA Records
         0      ! Number of SIDE SET Properties
! Information Records
         0      ! information records
! Variable names
         0         0         0      ! global, nodal element variables""")
                    
        f.close()
        print "txt形式への変換が完了しました"

    #  変換するtxtファイルの選択
    def converttxtfile(self,event):
        dbDir = self.textCtrl_workFolder.get_text()
        title = (u"変換するtxtfileの選択")
        filterSets = [[(u"textファイル"), "*.txt"]]
        fileName = self.fileDialog(title, dbDir, filterSets)
        if fileName == "":
            fileName = dbDir + "/" + "sample.txt"
        else:
            if fileName[-4:] != u".txt":
                fileName += u".txt"
            print "txtfileを　" + ("%s" % fileName) + "　に設定しました"
        self.textCtrl_usetxtfile.set_text(fileName)

    #  保存するgファイルの選択
    def savegenesisfile(self,event):
        dbDir = self.textCtrl_workFolder.get_text()
        title = (u"Genesisfileの選択")
        filterSets = [[(u"Genesisファイル"), "*.g"]]
        fileName = self.fileDialog(title, dbDir, filterSets)
        if fileName == "":
            fileName = dbDir + "/" + "sample.g"
        else:
            if fileName[-2:] != u".g":
                fileName += u".g"
            print "Genesisfileを　" + ("%s" % fileName) + "　に設定しました"
        self.textCtrl_savegfile.set_text(fileName)
        self.gfile = fileName
        self.fileName = self.textCtrl_workFolder.get_text()
        self.textCtrl_RunGenesisfile.set_text(fileName)

    #  trilinos変換
    def convertgenesis(self, event):
        if len(glob.glob(self.textCtrl_usetxtfile.get_text())) ==0:
            title = (u"txtfileの選択")
            mess = (u"ファイルが存在しません")
            self.errDialog(title, mess)
        elif self.textCtrl_savegfile.get_text() == "":
            title = (u"保存fileの選択")
            mess = (u"保存するfileを選択してください")
            self.errDialog(title, mess)
        elif len((self.textCtrl_savegfile.get_text()).split(".")) >= 3:
            title = (u"g形式の保存名")
            mess = (u"拡張子以外の.を外してください")
            self.errDialog(title, mess)
        else:
            comm = "txtexo" + " " + self.textCtrl_usetxtfile.get_text() + " " + self.textCtrl_savegfile.get_text()
            os.system(comm)
            self.setobjectinfo()

    def setobjectinfo(self):
        f = open('%s' %  self.textCtrl_usetxtfile.get_text(), "r")
        g = f.readline()
        g = f.readline()
        g = f.readline()
        g = f.readline()
        g = f.readline()
        g = g.split()
        totalnodes = g[0]
        totalelements = g[1]
        elements = [0]*int(g[2])
        objectnumber = int(g[2])
        g = f.readline()
        g = g.split()
        groupnumber = int(g[0])
        nodes = [0]*int(groupnumber)
        i = 0
        while i != objectnumber:
            if len(g)==8:
                if g[7] == 'type':
                    elements[i] = g[1]
                    i = i+1
            g = f.readline()
            g = g.split()
        i = 0
        while i != groupnumber:
            if len(g)==8:
                if g[7] == 'factors':
                    nodes[i] = g[1]
                    i = i+1
            g = f.readline()
            g = g.split()
        f.close()
        
        objectinfo = u"""ファイル名    :%s

  total elements :%10s
  total nodes :%10s
""" % (self.textCtrl_savegfile.get_text(),totalelements,totalnodes )
        for i in range(len(elements)):
            objectinfo += """
  object%s
          elements :%10s""" % (i+1,elements[i])
        objectinfo += "\n"
        for i in range(len(nodes)):
            objectinfo += """
  group%s
          nodes :%10s""" % (i+1,nodes[i])
        self.gfileinfo.set_label(objectinfo)
        
#---- Set_Material page------------------------------------------------------------------
    #  setmatTypes
    def setmaterialNametocombobox(self):
        self.comboboxmatTypes.clear()
        self.comboBox_matModel.clear()
        for name in materialTypes():
            self.comboboxmatTypes.append([name])
        cell = gtk.CellRendererText()
        self.comboBox_matModel.pack_start(cell,True)
        self.comboBox_matModel.add_attribute(cell,"text",0)
        self.comboBox_matModel.set_model(self.comboboxmatTypes)
        self.comboBox_matModel.set_active(0)

    #  setMaterialDB
    #    材料DBの場所を設定 参照...
    def setMaterialDB(self, event):
        global materialDBName
        if len(glob.glob(materialDBName)) == 0:
            DBDir = os.getcwd()
        else:
            DBDir = os.sep.join(materialDBName.split(os.sep)[:-1])
        fileType = "*.csv"

        title = (u"材料DBの選択")
        filterSets = [[(u"csvファイル"), "*.csv"]]
        fileName = self.fileDialog(title, DBDir, filterSets)
        if fileName != "":
            materialDBName = fileName
            self.textCtrl_matDB.set_text(materialDBName)
            self.readMaterialDB()
            self.setMaterialNameToListBox()
            self.setShotMaterialNameToListBox()
        return

#---- Set_Material_sub page--------------------------------------------------------------
    #  readMaterialDB
    #    材料DBを読み込み表示
    def readMaterialDB(self):
        global materialDBCont,materialDBName,materialDBCont
        materialDBName = "/opt/peridigm/fraxst/materialFRAXST.csv"
        self.textCtrl_matDB.set_text(materialDBName)
        fileName = materialDBName
        if len(glob.glob(fileName)) == 0:
            return

        data = pyFistr.readCsvData(fileName)
        materialDBCont = []
        i = 2
        while i < len(data):
            mat = data[i]
            materialDBCont.append(mat[0])
            i += 1
        materialDBCont.sort()
        self.setMaterialNameToListBox()
        
    #    材料名をlistBoxにセット
    def setMaterialNameToListBox(self):
        global materialDBCont
        self.listmodelMatName.clear()
        self.comboBox_matName.clear()
        for name in materialDBCont:
            self.listmodelMatName.append([name])
        cell = gtk.CellRendererText()
        self.comboBox_matName.pack_start(cell, True)
        self.comboBox_matName.add_attribute(cell, "text", 0)
        self.comboBox_matName.set_model(self.listmodelMatName)
        self.comboBox_matName.set_active(0)

    #    showtargetmaterialdata
    #    設定した材料の物性値を表示
    def showmaterialdata(self, event):
        matName = self.comboBox_matName.get_active_text()
        elastic = getMaterialElasticValue(matName)
        if len(elastic) == 0:
            title = ("エラー")
            mess = (u"材料名が設定されていません。")
            self.errDialog(title, mess)
            return

#        matValType = getMaterialValueType(matName)
#弾塑性解析
        mess = "density      \t" + elastic[1] + ls
        mess += "bulk_modulus \t" + elastic[2] + ls
        mess += "shear_modulus\t" + elastic[3] + ls
        if elastic[0] != "":
            mess  += "yield_stress \t" + elastic[0] + ls
        title = (u"材料の物性値")
        mess = (u"材料DB内の ") + matName + (u" の物性値   ") + ls + mess
        self.okDialog(title, mess)

    #---- 物性値の確定-----------------------------------------------------
        
    #    入力範囲の決定
    def changematerialmodel(self,event):
       if self.comboBox_matModel.get_active_text() == u"弾性硬化モデル":
           self.textCtrl_Surrender_Young.set_sensitive(True)
           self.textCtrl_Delay_time.set_sensitive(False)
           self.textCtrl_Relaxation_time.set_sensitive(False)
       elif self.comboBox_matModel.get_active_text() == u"粘弾性モデル":
           self.textCtrl_Surrender_Young.set_sensitive(False)
           self.textCtrl_Delay_time.set_sensitive(True)
           self.textCtrl_Relaxation_time.set_sensitive(True)
       else:
           self.textCtrl_Surrender_Young.set_sensitive(False)
           self.textCtrl_Delay_time.set_sensitive(False)
           self.textCtrl_Relaxation_time.set_sensitive(False)
        
    def setmaterialsub(self,event):
        self.Material = []
        self.Brittleness = []
        #物性値の取得
        self.matrialtype()
        self.Elastic_Plastic_Hardening()
        self.Viscoelastic()
        self.Elastic()
        self.Brittleness_model()
        if self.checkBtn_brittleness.get_active() == True:
            if self.textCtrl_Critical_Stretch.get_text() == "":
                title = (u"Set_Material_sub")
                mess = (u"限界伸びが入力されていません")
                self.errDialog(title, mess)
            else:
                self.Materialselect()
        else:
            self.Materialselect()

    #    材料特性の決定
    def matrialtype(self):
        self.Material += [self.comboBox_matName.get_active_text()]
        matType = self.comboBox_matModel.get_active_text()
        if matType == u"塑性モデル":
            self.Material += ["Elastic"]
        elif matType == u"弾塑性モデル":
            self.Material += ["Elastic Plastic"]
        elif matType == u"弾性硬化モデル":
            self.Material += ["Elastic Plastic Hardening"]
        elif matType == u"粘弾性モデル":
            self.Material += ["Viscoelastic"]
            
        matName = self.comboBox_matName.get_active_text()
        elastic = getMaterialElasticValue(matName)
        for i in range (4):
            self.Material += [elastic[i]]
            
    #    硬化モデルの設定
    def Elastic_Plastic_Hardening(self):
        if self.Material[1] == u"Elastic Plastic Hardening":
            if self.textCtrl_Surrender_Young.get_text() != "":
                Surrender_Young = float(self.Material[2])/float(self.textCtrl_Surrender_Young.get_text())
                self.Material += [Surrender_Young]
        else:
            self.Material += [""]
            
    #    粘弾性モデル
    def Viscoelastic(self):
        if self.Material[1] == (u"Viscoelastic"):
            self.Material += [self.textCtrl_Delay_time.get_text()]
            self.Material += [self.textCtrl_Relaxation_time.get_text()]
            self.Material[2] = ("")
        else:
            self.Material += [""]
            self.Material += [""]
            
    #    塑性モデル
    def Elastic(self):
        if self.Material[1] == u"Elastic":
            self.Material[2] = ("")

    def onbrittleness(self,event):
        if self.checkBtn_brittleness.get_active() == True:
            self.textCtrl_Critical_Stretch.set_sensitive(True)
        else:
            self.textCtrl_Critical_Stretch.set_sensitive(False)
            
    #    脆性モデルの有無
    def Brittleness_model(self):
        self.Brittleness += [self.checkBtn_brittleness.get_active()]
        self.Brittleness += [self.pagename]
        self.Material += [self.textCtrl_Critical_Stretch.get_text()]
        
    #    pagenameの取得
    def Material_pagename(self):
        self.Material += [self.pagename]

    #    影響半径の決定
    def Horizon(self):
        self.Material += [self.textCtrl_horizon.get_text()]

    #    表示
    def Materialselect(self):
        self.Material_pagename()
        self.Horizon()
        self.Materialoverlap()
        if self.Material[11] == "":
            title = (u"Set_Material_sub")
            mess = (u"影響半径が入力されていません")
            self.errDialog(title, mess)
        else:
            print u"%sの材料を%s(%s)に設定しました" % (self.pagename,self.comboBox_matName.get_active_text()
                                                ,self.comboBox_matModel.get_active_text())
        
    #    重複の削除
    def Materialoverlap(self):
        global Materiallist,Brittlenesslist
        if len(Materiallist) == 0:
            Materiallist += [self.Material]
            Brittlenesslist += [self.Brittleness]
        else:
            if len(Materiallist) < (len(MaterialNamelist)):
                Materiallist += [self.Material]
                Brittlenesslist += [self.Brittleness]
                error = self.Material[10] in Materiallist[0]
                if error == True:
                    del Materiallist[0]
                Berror = self.Brittleness[1] in Brittlenesslist[0]
                if Berror  == True:
                    del Brittlenesslist[0]
            else:
                for i in range(0,len(MaterialNamelist)):
                    error = self.Material[10] in Materiallist[i]
                    Berror = self.Brittleness[1] in Brittlenesslist[i]
                    if error == True:
                        Materiallist[i][:] = self.Material
                    if Berror == True:
                        Brittlenesslist[i][:] = self.Brittleness

    #    combobox内をクリア
    def materialclear(self):
        for i in range(len(Materiallist)):
            if self.pagename in Materiallist[i]:
                matTypes = materialTypesE()
                for j in range(len(matTypes)):
                    matType = matTypes[j]
                    if matType == Materiallist[i][1]:
                        self.comboBox_matModel.set_active(j)
                        break
            if self.pagename in Materiallist[i]:
                for j in range(len(materialDBCont)):
                    matName = materialDBCont[j]
                    if matName == Materiallist[i][0]:
                        self.comboBox_matName.set_active(j)
                        break
                if Materiallist[i][6] != "":
                    self.textCtrl_Surrender_Young.set_text(str(float(Materiallist[i][2])/float(Materiallist[i][6])))
                else:
                    self.textCtrl_Surrender_Young.set_text("")
                self.textCtrl_Delay_time.set_text(Materiallist[i][7])
                self.textCtrl_Relaxation_time.set_text(Materiallist[i][8])
                self.textCtrl_Critical_Stretch.set_text(Materiallist[i][9])
                self.checkBtn_brittleness.set_active(Brittlenesslist[i][0])
                if Brittlenesslist[i][0] == True:
                    self.textCtrl_Critical_Stretch.set_sensitive(True)
                else:
                    self.textCtrl_Critical_Stretch.set_sensitive(False)
                self.textCtrl_horizon.set_text(Materiallist[i][11])
                break
            else:
                self.comboBox_matModel.set_active(0)
                self.comboBox_matName.set_active(0)
                self.textCtrl_Surrender_Young.set_text("")
                self.textCtrl_Delay_time.set_text("")
                self.textCtrl_Relaxation_time.set_text("")
                self.checkBtn_brittleness.set_active(False)
                self.textCtrl_Critical_Stretch.set_sensitive(False)
                self.textCtrl_Critical_Stretch.set_text("")
                self.textCtrl_horizon.set_text("")

#---- SetBoundary_page-----------------------------------------------------------
    def setboundary(self,event):
        self.contact = []
        if self.checkBtn_contact.get_active() == True:
            self.contact += [self.textCtrl_search_radius.get_text()]
            if self.contact[0] =="":
                title = (u"Set_Boundary")
                mess = (u"探索半径が入力されていません")
                self.errDialog(title, mess)
            else:
                self.contact += [self.textCtrl_search_frequency.get_text()]
                if self.contact[1] =="":
                    title = (u"Set_Boundary")
                    mess = (u"探索頻度が入力されていません")
                    self.errDialog(title, mess)
                else:
                    self.contact += [self.textCtrl_contact_radius.get_text()]
                    if self.contact[2] =="":
                        title = (u"Set_Boundary")
                        mess = (u"衝突半径が入力されていません")
                        self.errDialog(title, mess)
                    else:
                        self.contact += [self.textCtrl_spring_constact.get_text()]
                        if self.contact[3] =="":
                            title = (u"Set_Boundary")
                            mess = (u"バネ定数が入力されていません")
                            self.errDialog(title, mess)
                        else:
                            print u"接触解析に設定しました"
        else:
            print u"非接触解析に設定しました"

    def oncontact(self,event):
        if self.checkBtn_contact.get_active() == True:
            self.textCtrl_search_radius.set_sensitive(True)
            self.textCtrl_search_frequency.set_sensitive(True)
            self.textCtrl_contact_radius.set_sensitive(True)
            self.textCtrl_spring_constact.set_sensitive(True)
        else:
            self.textCtrl_search_radius.set_sensitive(False)
            self.textCtrl_search_frequency.set_sensitive(False)
            self.textCtrl_contact_radius.set_sensitive(False)
            self.textCtrl_spring_constact.set_sensitive(False)

#---- SetBoundary_sub_page-----------------------------------------------------------
        #  setmatTypes
    def setanalysistypestocombobox(self):
        self.comboboxanaTypes.clear()
        self.comboBox_anaTypes.clear()
        for name in analysisTypes():
            self.comboboxanaTypes.append([name])
        cell = gtk.CellRendererText()
        self.comboBox_anaTypes.pack_start(cell,True)
        self.comboBox_anaTypes.add_attribute(cell,"text",0)
        self.comboBox_anaTypes.set_model(self.comboboxanaTypes)
        self.comboBox_anaTypes.set_active(0)

    #    決定
    def setboundarysub(self,event):
        self.boundary = []
        self.analysisType()
        self.value()
        self.Boundarypagename()
        self.Boundaryoverlap()
        print u"%sの制御方法を%sに設定しました" % (self.pagename,self.anaType)
        
    #    解析方法の決定
    def analysisType(self):
        self.anaType = self.comboBox_anaTypes.get_active_text()
        if self.anaType == u"変位制御(m)":
            self.boundary += ["Prescribed Displacement"]
        elif self.anaType == u"初速度(m/s)":
            self.boundary += ["Initial Velocity"]
        elif self.anaType == u"温度制御":
            self.boundary += ["Prescribed Temperature"]
        elif self.anaType == u"体積力":
            self.boundary += ["Body Force"]
    #    衝突速さの算出
    def value(self):
        value_x = self.textCtrl_Value_X.get_text()
        self.boundary +=[value_x]
        value_y = self.textCtrl_Value_Y.get_text()
        self.boundary += [value_y]
        value_z = self.textCtrl_Value_Z.get_text()
        self.boundary += [value_z]
    #    pagenameの取得
    def Boundarypagename(self):
        self.boundary += [self.pagename]
    #    重複の削除
    def Boundaryoverlap(self):
        global Boundarylist
        if len(Boundarylist) == 0:
            Boundarylist += [self.boundary]
        else:
            if len(Boundarylist) < (len(BoundaryNamelist)):
                Boundarylist += [self.boundary]
                error = self.boundary[4] in Boundarylist[0]
                if error == True:
                    del Boundarylist[0]
            else:
                for i in range(0,len(MaterialNamelist)):
                    error = self.boundary[4] in Boundarylist[i]
                    if error == True:
                        Boundarylist[i][:] = self.boundary
        
    #    page内クリア
    def boundaryclear(self):
        for i in range(0,len(Boundarylist)):
            if self.pagename in Boundarylist[i]:
                analyTypes = analysisTypesE()
                for j in range(len(analyTypes)):
                    analyType = analyTypes[j]
                    if analyType == Boundarylist[i][0]:
                        self.comboBox_anaTypes.set_active(j)
                        break
                self.textCtrl_Value_X.set_text(Boundarylist[i][1])
                self.textCtrl_Value_Y.set_text(Boundarylist[i][2])
                self.textCtrl_Value_Z.set_text(Boundarylist[i][3])
                break
            else:
                self.comboBox_anaTypes.set_active(0)
                self.textCtrl_Value_X.set_text("")
                self.textCtrl_Value_Y.set_text("")
                self.textCtrl_Value_Z.set_text("")

    #  Solver------------------------------------------------------------------------
    def setsolver(self,event):
        self.finaltime = self.textCtrl_Final_Time.get_text()
        self.fixdt = self.textCtrl_Fix_dt.get_text()
        step = (float(self.finaltime))/(float(self.fixdt))
        print u"Step数を"+("%s"%int(step))+u"に設定しました。"

    #  peridigm形式の保存名の選択
    def peridigmfile(self, event):
        peridigmDir = self.textCtrl_workFolder.get_text()
        title = (u"保存ファイルの選択")
        filterSets = [[(u"peridigmファイル"), "*.peridigm"]]
        self.peridigmworkName = self.fileDialog(title, peridigmDir, filterSets)
        if self.peridigmworkName == "":
            self.peridigmworkName = peridigmDir + "/" + "sample.peridigm"
            fileName = "sample.peridigm"
            
        else:
            if self.peridigmworkName[-9:] != u".peridigm":
                self.peridigmworkName += u".peridigm"
            fileName = self.peridigmworkName.split("/")[-1]
            print "保存fileを　" + ("%s" % self.peridigmworkName) + "　に設定しました"
        self.textCtrl_PeridigmFile.set_text(self.peridigmworkName)
        self.peridigmworkName = self.peridigmworkName
        self.peridigmfileName = fileName

        self.runperidigmworkName = self.textCtrl_workFolder.get_text()
        self.textCtrl_RunPeridigmfile.set_text(self.peridigmworkName)

#---- 変換------------------------------------------------------------------------------
    def convertperidigm(self,event):
        self.gfilename = (self.textCtrl_savegfile.get_text()).rsplit("/",1)
        
        self.efile = self.textCtrl_Setefile.get_text()
        result = u"peridigm形式への変換が完了しました"

        if len((self.efile).split(".")) >= 3:
            title = (u"e形式の保存名")
            mess = (u"ファイル名の.を外してください")
            self.errDialog(title, mess)
            result =""

        elif len((self.efile).split(".")) == 2:
            if self.efile[-2:] != ".e":
                title = (u"e形式の保存名")
                mess = (u"拡張子は.eです")
                self.errDialog(title, mess)
                result = ""
            else:
                self.efile = self.efile[:-2]
                
        if self.textCtrl_Final_Time.get_text() == "" or self.textCtrl_Final_Time.get_text() == "0":
            title = (u"Convert_Peridigm")
            mess = (u"衝突時間が入力されていません")
            self.errDialog(title, mess)
        else:
            if self.textCtrl_PeridigmFile.get_text() == "":
                title = (u"peridigmfileの選択")
                mess = (u"ファイルが存在しません")
                self.errDialog(title, mess)
            else:
                self.outputtime()
                self.writing_peridigm()
                if len((self.textCtrl_PeridigmFile.get_text()).split(".")) >= 3:
                    title = (u"peridigm形式の保存名")
                    mess = (u"拡張子以外の.を外してください")
                    self.errDialog(title, mess)
                else:
                    if result != "":
                        print "%s" % (result)
        
#---- 出力時間の設定-------------------------------------------
    def outputtime(self):
        self.finaltime = self.textCtrl_Final_Time.get_text()
        self.fixdt = self.textCtrl_Fix_dt.get_text()
        self.output_frequency = self.textCtrl_output_frequency.get_text()
        
#---- .peridigm形式-------------------------------------------
    def writing_peridigm(self):
        cood =["x","y","z"]
        fileName = self.textCtrl_PeridigmFile.get_text()
        f = open(fileName,"w")
        f.write("""
#     Description
#       Simulation of an elastic sphere impacting a brittle elastic disk.
#       A critical stretch bond failure law is applied to the disk.
#
#     Units are SI
#       mass          kg
#       length        m
#       time          s
#       density       kg/m^3
#       force         N
#       pressure      Pa
#       velocity      m/s
#       acceleration  m/s^2
#       energy        J

Discretization
    Type "Exodus"
    Input Mesh File "%s"
""" %(self.gfilename[-1]))
        
#---- Materials--------------------------------------------------------
        f.write("""
Materials""")
        
        for i in range(len(MaterialNamelist)):
            f.write("""
    %s Material
        Material Model "%s"
        Density %s
        Bulk Modulus %s 
        Shear Modulus %s""" % (MaterialNamelist[i][:-4],Materiallist[i][1],
                               Materiallist[i][3],Materiallist[i][4],
                               Materiallist[i][5]))

            if Materiallist[i][2] !="":
                f.write("""
        Yield Stress %s """ % (Materiallist[i][2]))
                
            if Materiallist[i][6] != "":
                f.write("""
        Hardening Modulus %s """ % (Materiallist[i][6]))

            if Materiallist[i][7] != "":
                f.write("""
        lambda_i %s 
        tau b %s""" % (Materiallist[i][7],Materiallist[i][8]))

            
#---- Damage Models-------------------------------------------------
        for i in range (len(MaterialNamelist)):
            if Brittlenesslist[i][0] == True:
                f.write("""\n
Damage Models""")
                break
                
        for i in range(len(MaterialNamelist)):
                    
            if Brittlenesslist[i][0] == True:
                f.write("""
    %s Damage Model
        Damage Model "Critical Stretch"
        Critical Stretch %s""" % (MaterialNamelist[i][:-4],Materiallist[i][9]))

#---- Blocks--------------------------------------------------------
        f.write("""\n
Blocks""")
        
        for i in range(len(MaterialNamelist)):
            f.write( """
    %s Block
        Block Names "block_%d"
        Material "%s Material" """ % (MaterialNamelist[i][:-4],i+1,
                                      MaterialNamelist[i][:-4]))
            if Brittlenesslist[i][0] == True:
                f.write("""
        Damage Model "%s Damage Model" """ % (MaterialNamelist[i][:-4]))

            f.write("""
        Horizon %s""" % (Materiallist[i][11]))

#---- Contact-------------------------------------------------------
        if len(self.contact) != 0:
            f.write("""\n
Contact
    Search Radius %s
    Search Frequency %s
    Models 
        My Contact Model 
            Contact Model "Short Range Force"
            Contact Radius %s
            Spring Constant %s
    Interactions
        Interaction Target with Shot 
            First Block "block_1"
            Second Block "block_2"
            Contact Model "My Contact Model"\n
Boundary Conditions""" % (self.contact[0],self.contact[1],
                          self.contact[2],self.contact[3]))
        else:
            f.write("""\n
Boundary Conditions""")

#---- Boundary Conditions Load--------------------------------------------
        for i in range(len(BoundaryNamelist)):
            for j in range(0,3):
                if Boundarylist[i][1+j] == "":
                    a = j
                elif Boundarylist[i][1+j] == "0":
                        f.write("""
    %s_%s
        Type "Prescribed Displacement"
        Node Set "nodelist_%d"
        Coordinate "%s"
        Value "0" """ % (BoundaryNamelist[i][:-4],cood[j],i+1,cood[j]))
                else:
                    f.write("""
    %s_%s
        Type "%s"
        Node Set "nodelist_%d"
        Coordinate "%s"
        Value "%s" """ % (BoundaryNamelist[i][:-4],cood[j],Boundarylist[i][0],
                          i+1,cood[j],Boundarylist[i][1+j]))

#---- Solver--------------------------------------------------------------
        f.write("""\n
Solver
    Initial Time 0.0
    Final Time %s""" % (self.finaltime))

        if self.fixdt =="":
            f.write("""
    Verlet
        Safety Factor 0.7
        """)
        else:
            f.write("""
    Verlet
        Fixed dt %s
        """ % (self.fixdt))

#---- Output_1-----------------------------------------------------------
        f.write("""
Output_1
    Output File Type "ExodusII"
    Output Filename "%s"
    Output Frequency %s
    Output Variables""" % (self.efile,int(self.output_frequency)))
        if self.checkBtn_Displacement.get_active() == True:
            f.write("""
        Displacement "true" """)

        if self.checkBtn_Velocity.get_active() == True:
            f.write("""
        Velocity "true" """)

        if self.checkBtn_Element_Id.get_active() == True:
            f.write("""
        Element_Id "true" """)

        if self.checkBtn_Proc_Num.get_active() == True:
            f.write("""
        Proc_Num "true" """)

        if self.checkBtn_Dilatation.get_active() == True:
            f.write("""
        Dilatation "true" """)

        if self.checkBtn_Weighted_Volume.get_active() == True:
            f.write("""
        Weighted_Volume "true" """)

        if self.checkBtn_Force.get_active() == True:
            f.write("""
        Force "true" """)

        if self.checkBtn_Contact_Force.get_active() == True:
            f.write("""
        Contact_Force "true" """)

        if self.checkBtn_Damage.get_active() == True:
            f.write("""
        Damage "true" """)

        if self.checkBtn_Number_Of_Neighbors.get_active() == True:
            f.write("""
        Number_Of_Neighbors "true" """)

        if self.checkBtn_Radius.get_active() == True:
            f.write("""
        Radius "true" """)

        if self.checkBtn_Acceleration.get_active() ==True:
            f.write("""
        Acceleration "true" """)
        if self.checkBtn_Force_Density.get_active() ==True:
            f.write("""
        Force_Density "true" """)
            
        f.close()        

    #  Genesisファイルの設定(ダイヤログ)------------------------------------------------------
    def setgenesisfile(self,event):
        dbDir = self.textCtrl_RunGenesisfile.get_text()
        title = (u"Genesisfileの選択")
        filterSets = [[(u"Genesisファイル"), "*.g"]]
        fileName = self.fileDialog(title, dbDir, filterSets)
        if fileName == "":
            fileName = dbDir + "/" + "sample.g"
        else:
            if fileName[-2:] != u".g":
                fileName += u".g"
            print "Genesisfileを　" + ("%s" % fileName) + "　に設定しました"
        self.textCtrl_RunGenesisfile.set_text(fileName)
        self.gfile = fileName

    #  Peridigmファイルの設定(ダイヤログ)------------------------------------------------------
    def setperidigmfile(self, event):
        peridigmDir = self.textCtrl_workFolder.get_text()
        title = (u"保存ファイルの選択")
        filterSets = [[(u"peridigmファイル"), "*.peridigm"]]
        peridigmworkName = self.fileDialog(title, peridigmDir, filterSets)
        if peridigmworkName == "":
            peridigmworkName = peridigmDir + "/" + "sample.peridigm"
        else:
            if peridigmworkName[-9:] != u".peridigm":
                peridigmworkName += u".peridigm"
            fileName = peridigmworkName.split("/")[-1]
            print "Peridigmファイルを　" + ("%s" % peridigmworkName) + "　に設定しました"
        self.textCtrl_RunPeridigmfile.set_text(peridigmworkName)
        self.peridigmfileName = fileName
        
#   Peridigmの実行-------------------------------------------------------------------------
    def runperidigm(self,event):
        start = time.time()
        self.efile = self.textCtrl_Setefile.get_text()
        parallelSwitch = self.checkBtn_solvePara.get_active()
        self.CPUcore = self.textCtrl_CPUcore.get_text()
        self.runperidigmworkName = self.textCtrl_workFolder.get_text()
        os.chdir(self.runperidigmworkName)

        if parallelSwitch == True:
            if self.CPUcore =="" or self.CPUcore == "0":
                title = (u"peridigmfileの選択")
                mess = (u"ファイルが存在しません")
                self.errDialog(title, mess)
            else:
                self.multiple_peridigm()
        else:
            self.single_peridigm()
            
    #  解析時間の計測
        endtime= time.time() -start
        hour = int(math.floor(endtime/3600))
        minute = int(math.floor((endtime - hour*3600)/60))
        sec = endtime - (minute*60+hour*3600)
        if hour < 10:
            hour = "0"+ str(hour)
        if minute < 10:
            minute = "0"+ str(minute)
        if sec < 10.0:
            sec = "0"+ str(sec)

        print u"処理時間は%s:%s:%s" % (hour,minute,sec)
                        
        title = u"Peridigm"
        mess = u".eファイルの作成に成功しました"
        self.okDialog(title, mess)
        
    #  CPU数の判定
    def multiple_processing(self,event):
        parallelSwitch = self.checkBtn_solvePara.get_active()
        if parallelSwitch == True:
            self.textCtrl_CPUcore.set_sensitive(True)
            CPUcount = multiprocessing.cpu_count()
            self.textCtrl_CPUcore.set_text(str(CPUcount))
        else:
            self.textCtrl_CPUcore.set_sensitive(False)
            self.textCtrl_CPUcore.set_text("")
            
    def multiple_peridigm(self):
    #  .gファイルの分割
        self.gfilename = (self.textCtrl_RunGenesisfile.get_text()).rsplit("/",1)
        self.peridigmfileName = (self.textCtrl_RunPeridigmfile.get_text()).rsplit("/",1)
        comm = "decomp -p %s %s" %(self.CPUcore,self.gfilename[-1])
        os.system(comm)
    #  Peridigmの実行    
        comm = "mpirun -np %s /opt/peridigm/bin/Peridigm %s" % (self.CPUcore,self.peridigmfileName[-1])
        os.system(comm)
    #  .eファイルの結合
        comm = "/opt/peridigm/bin/MergeFiles.py %s %s" % (self.efile,self.CPUcore)
        os.system(comm)
            
    def single_peridigm(self):
        self.peridigmfileName = (self.textCtrl_RunPeridigmfile.get_text()).rsplit("/",1)
        comm = "/opt/peridigm/bin/Peridigm %s" % (self.peridigmfileName[-1])
        os.system(comm)

    #  efile確認
    def comfirmefile(self, event):
        self.efile = self.textCtrl_Setefile.get_text()
        istrData = getSavedData()
        efilefolder = self.textCtrl_workFolder.get_text()
        for i in range(len(istrData)):
            item = istrData[i].split()
            if item[0] == u'paraview':
                paraview = item[1]
        if len(self.textCtrl_Setefile.get_text()) == 0:
            title = (u"efileの選択")
            mess = (u"ファイルが存在しません")
            self.errDialog(title, mess)
        else:
            comm = paraview + " " + "%s.e" % (efilefolder+"/"+self.efile)
            os.system(comm)
            
#---------------------------------------------------------------------------------------

    #  形状確認
    def confirmModelAtParaview(self, event):
        self.gfile = self.textCtrl_RunGenesisfile.get_text()
        istrData = getSavedData()
        for i in range(len(istrData)):
            item = istrData[i].split()
            if item[0] == u'paraview':
                paraview = item[1]
        if len(glob.glob(self.textCtrl_savegfile.get_text())) == 0:
            title = (u"Genesisfileの選択")
            mess = (u"ファイルが存在しません")
            self.errDialog(title, mess)
        else:
            comm = paraview + " " + "%s" % (self.gfile)
            os.system(comm)

    #  salome起動
    def runsalome(self, event):
        istrData = getSavedData()
        for i in range(len(istrData)):
            item = istrData[i].split()
            if item[0] == u'salome':
                comm = item[1]
        comm += " &"
        os.system(comm)

    #  paraview起動
    def runparaview(self, event):
        istrData = getSavedData()
        for i in range(len(istrData)):
            item = istrData[i].split()
            if item[0] == u'paraview':
                comm = item[1]
        os.system(comm)

    #  editor起動
    def runeditor(self, event):
        comm = "gedit"
        os.system(comm)        

    #  環境設定
    def environset(self, event):
        title = u"環境設定"
        self.subWindow.set_title(title)
        point = self.mainWindow.get_position()
        size = self.mainWindow.get_size()
        (pointx,pointy) = point
        (sizex,sizey)= size
        repointx = pointx+sizex/2
        repointy = pointy+sizey/2
        self.subWindow.move(repointx,repointy)
        self.subWindow.show_all()
        subsize = self.subWindow.get_size()
        (subx,suby) = subsize
        repointx = repointx-subx/2
        repointy = repointy-suby/2
        self.subWindow.move(repointx,repointy)

    #  環境設定の初期化
    def environinit(self,event):
        item = 'salome'
        path = '/opt/salome/appli_V7_4_0/salome'
        self.changedatafile(item, path)
        item = 'paraview'
        path = '/opt/ParaView-4.3.1-Linux-64bit/bin/paraview'
        self.changedatafile(item, path)
        item = 'materialdata'
        path = '/opt/peridigm/fraxst/material.csv'
        self.changedatafile(item, path)
        istrData = getSavedData()
        for i in range(len(istrData)):
            item = istrData[i].split()
            if item[0] == u'materialdata':
                self.textCtrl_MaterialDataPATH.set_text(item[1])
            elif item[0] == u'salome':
                self.textCtrl_SalomePATH.set_text(item[1])
            elif item[0] == u'paraview':
                self.textCtrl_ParaviewPATH.set_text(item[1])

    #  設定変更
    def saveenvironment(self, event):
        item = 'materialdata'
        path = self.textCtrl_MaterialDataPATH.get_text()
        self.changedatafile(item, path)
        item = 'salome'
        path = self.textCtrl_SalomePATH.get_text()
        self.changedatafile(item, path)
        item = 'paraview'
        path = self.textCtrl_ParaviewPATH.get_text()
        self.changedatafile(item, path)

    #  fraxst_dataの更新
    def changedatafile(self, changeitem, path):
        istrData = getSavedData()
        fileName = datafile
        f = open(fileName,'w')
        f.write("""#
# fraxst用data
#
""")
        for i in range(len(istrData)):
            item = istrData[i].split()
            if item[0] == changeitem:
                item[1] = ""
                item[1] = path
                pathdata = path
            else:
                pathdata = item[1]
            f.write("""# %s
%s %s\n\n""" % (item[0],item[0],pathdata))
        f.close()

    #    選択したitemをlistBox1からlistBox2に移動する
    def moveItemToListBox(self, listBox1, listmodel1, listBox2, listmodel2):
        (listmodel, listIter) = listBox1.get_selection().get_selected()
        if listIter != None:
            selName = listmodel.get_value(listIter, 0)
        else:
            title = (u"fileの選択")
            mess = (u"file名を選択してください")
            self.errDialog(title, mess)
            return

        #元listBoxからselNameを削除
        listmodel.remove(listIter)
        #先listBoxにselNameを追加
        toNames = self.getNamesInListmodel(listmodel2)
        names = [selName]
        toNames += names
        self.setListDataInListBox(listmodel2, listBox2, toNames)
        #selNameを選択表示。
        n = 0
        for name in toNames:
            if name == selName:
                break
            n += 1
        path = (n)
        listBox2.get_selection().select_path(path)

    #----------comboBox, listBoxの設定----------------------
    #
    #  getNamesInListmodel
    #    listmodelから全namesを取得
    def getNamesInListmodel(self, listmodel):
        names = []
        iter = listmodel.get_iter_first()
        while iter != None:
            name = listmodel.get_value(iter, 0)
            names.append(name)
            iter = listmodel.iter_next(iter)
        return names

    #
    #  setListDataInListBox
    #    listBox(TreeView)をクリアしてデータをセットする
    def setListDataInListBox(self, listModel, listBox, setNames):
        listModel.clear()
        for name in setNames:
            listModel.append([name])
        listBox.set_model(model=listModel)
        cols = [""]
        for i in range(len(cols)):
            coll = listBox.get_column(i)
            if coll != None:
                listBox.remove_column(coll)
            cell = gtk.CellRendererText()
            col = gtk.TreeViewColumn(cols[i], cell, text=i)
            listBox.append_column(col)
        listBox.set_headers_visible(False)

    #
    #
    #  setComboDataInComboBox    
    #    comboBoxをクリアしてデータをセットする
    def setComboDataInComboBox(self, listModel, comboBox, setNames):
        listModel.clear()
        comboBox.clear()
        for name in setNames:
            listModel.append([name])
        cell = gtk.CellRendererText()
        comboBox.pack_start(cell, True)
        comboBox.add_attribute(cell, "text", 0)
        comboBox.set_model(listModel)

    #
    #  setComboActiveText
    #    comboBoxの指定したtextをactiveに設定
    def setComboActiveText(self, comboBox, selName, names):
        n = 0
        for name in names:
            if name == selName:
                break
            n += 1
        comboBox.set_active(n)

    #---universal dialog--------------
    def fileDialog(self, title, fileDir, filterSets):
        dlg = gtk.FileChooserDialog(
                    title = title,
                    parent = None,
                    action = gtk.FILE_CHOOSER_ACTION_OPEN,
                    buttons = (gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL,
                              gtk.STOCK_OPEN, gtk.RESPONSE_OK))
        for [name, pattern] in filterSets:
            filter = gtk.FileFilter()
            filter.set_name(name)
            filter.add_pattern(pattern)
            dlg.add_filter(filter)
        dlg.set_current_folder(fileDir)
        stat = dlg.run()
        if stat == gtk.RESPONSE_OK:
            fileName = dlg.get_filename()
        else:
            fileName = ""
        dlg.destroy()
        return fileName

    def dirDialog(self, title, path):
        dlg = gtk.FileChooserDialog(
                    title = title,
                    parent = None,
                    action = gtk.FILE_CHOOSER_ACTION_SELECT_FOLDER,
                    buttons = (gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL,
                              gtk.STOCK_OPEN, gtk.RESPONSE_OK))
        dlg.set_current_folder(path)
        result = dlg.run()
        if result == gtk.RESPONSE_OK:
            folderDir = dlg.get_filename()
        else:
            folderDir = ""
        dlg.destroy()
        return folderDir

    def errDialog(self, title, message):
        dlg = gtk.MessageDialog(type=gtk.MESSAGE_ERROR, buttons=gtk.BUTTONS_OK)
        dlg.set_title(title)
        mess1 = message.split(ls)[0]
        mess2 = ls.join(message.split(ls)[1:])
        dlg.set_markup(mess1)
        dlg.format_secondary_text(mess2)
        ans = dlg.run() 
        dlg.destroy()
    def okDialog(self, title, message):
        dlg = gtk.MessageDialog(type=gtk.MESSAGE_INFO, buttons=gtk.BUTTONS_OK)
        dlg.set_title(title)
        #messageを分ける
        mess1 = message.split(ls)[0]
        mess2 = ls.join(message.split(ls)[1:])
        dlg.set_markup(mess1)
        dlg.format_secondary_text(mess2)
        ans = dlg.run() 
        dlg.destroy()

#    初期のTreeDataを作成
def makeIniTreeData():
    global treeData, root1, root2, root3, root4, root5, root6, root7, root8
    #初期のTreeDataを取得
    [root1, root2, root3, root4, root5, root6, root7, root8] = initialTreeParts()
    makeTreeData()
    return

#    TreeDataを作成する
def makeTreeData():
    global treeData
    treeData = []
    treeData += root1
    items = []
    items += root2
    items += root3
    items += root4
    items += root5
    items += root6
    items += root7
    items += root8
 
    treeData += [items]

#    保存したデータの読み込み
def getSavedData():
    fileName = datafile
    f=open(fileName); cont=f.read(); f.close()
    ans = []
    lines = cont.split("\n")
    for line in lines:
        words = line.split()
        if len(words) > 1:
            if words[0][0] != "#":
                ans.append(line)
    return ans

#  getMaterialElasticValue
#    物性値（弾性）をDBから取得
def getMaterialElasticValue(matName):
    fileName = materialDBName
    data = pyFistr.readCsvData(fileName)
    matData = data[2:]
    vals = []
    for words in matData:
        if matName == words[0]:
            vals = words[1:7] #[model_Name,young, poisson, density, linearexp,critical_stretch]
    return vals

#  createMaterialDefine
#    材料定義を取得
def createMaterialDefine(lines):
    matDefine = []
    i = 0
    while i < len(lines):
        line = lines[i]
        if line[0] == "!":
            if line[:len("!ELEMENT")] == "!ELEMENT":
                elType = abaqus2fistr.getValName(line, "TYPE")
            if line[:len("!SECTION")] == "!SECTION":
                egrp = abaqus2fistr.getValName(line, "EGRP")
                matName = abaqus2fistr.getValName(line, "MATERIAL")
                matDefine.append([egrp, matName, elType])
        i += 1
    return matDefine

#----------------------------------------------------------------------------------------

if __name__ == "__main__":
    windowApp()
    gtk.main()
